#!/bin/busybox sh
grep -q '^/dev/mmcblk0p3' /proc/mounts || exit 0

[ add = "$ACTION" ] || exit 0
if [ -f /tmp/StopNickel_Stop_Count ] ; then
  read n < /tmp/StopNickel_Stop_Count
  [ $n -gt 999 ] && exit 0
fi
/root/bin/StopNickel.sh
wnk=$(mktemp /tmp/wnk_XXXXXX)
printf '5 8 0 8\n45 0 8 0\n' > $wnk
$FKSH_HOM/tools/whinker.sh $wnk
$FKSH_HOM/tools/dontNap.sh ON $$
onEXIT () {
  sync; sync
  /root/bin/ContNickel.sh
  rm -f $wnk
  $FKSH_HOM/tools/dontNap.sh OFF $$ 20
}
(
# run background
trap onEXIT EXIT
## close almost file descripters
for fdp in /proc/$$/fd/* ; do
  [ -e "$fdp" -o -L "$fdp" ] || continue
  fd=${fdp##*/}
  case "$fd" in
  0|1|2 ) ;;
  *) eval "exec $fd<&- $fd>&-" ;;
  esac
done

sqlOut=$FKSH_ONB/db
[ -d $sqlOut ] || mkdir $sqlOut
sqlOut=$sqlOut/autoUpdate.sql
db=/mnt/onboard/.kobo/KoboReader.sqlite
which sqlite3 || exit 0
tries=30
until grep -q '^/dev/mmcblk1p1' /proc/mounts ; do
  [ $tries -le 0 ] && exit 0
  tries=$(($tries - 1))
  usleep 100000
done
$FKSH_HOM/tools/autoUpdateSQL.sh > $sqlOut
errOut=/mnt/onboard/autoUpdateSQL.err
sqlite3 $db < $sqlOut 2> $errOut || sqlite3 $db < $sqlOut 2> $errOut
[ -s $errOut ] || rm -f $errOut
) </dev/null >/dev/null &

exit 0

